#buildvars

#include compat.js
#include common.js
#include ctx.js
#include loadoverlay.js
#include mszauth.js
#include ts_chat.js
#include mami/settings.js

(function() {
    var loading = new AmiLoadingOverlay(document.body, true);

    FutamiCommon.load(function(futami) {
        if(typeof futami !== 'object') {
            alert('Failed to load environment settings!');
            return;
        }

        window.futami = futami;

        var auth = new AmiMisuzuAuth(futami.get('token'));
        var refreshInfo = function(next) {
            auth.refresh(function(token) {
                if(token.ok === false) {
                    location.assign(futami.get('login') + '?legacy=1');
                    return;
                }

                if(typeof next === 'function')
                    next(token.ok);
            });
        };

        var ami = new AmiContext(futami.get('title'), auth, loading);
        window.ami = ami;

        setInterval(refreshInfo, 600000);
        refreshInfo(function() {
            Chat.Main(auth);

            ami.sockChat.open();
            window.addEventListener('beforeunload', () => ami.sockChat.close());
        });
    });
})();
